﻿
Imports System.Windows
Imports System.Windows.Controls
Imports SpiceLogic.HtmlEditorControl.Domain.BOs
Imports SpiceLogic.WpfHtmlEditor.EditorEventArgs


''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
    Inherits Window
    Public Sub New()
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' Handles Click event of the ImageProperties context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_imageProperties_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.ToolbarItemOverrider.OnImageButtonClicked(sender, e)
    End Sub

    ''' <summary>
    ''' Handles Click event of the LinkProperties context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_linkProperties_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.ToolbarItemOverrider.OnHyperLinkButtonClicked(sender, e)
    End Sub

    ''' <summary>
    ''' Handles Click event of the CellProperties context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_cellProperties_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.ToolbarItemOverrider.OnTableCellEditingClicked(sender, e)
    End Sub

    ''' <summary>
    ''' Handles Click event of the TableProperties context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub tablePropertiesToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.ToolbarItemOverrider.OnTableModifyButtonClicked(sender, e)
    End Sub

    ''' <summary>
    ''' Handles Click event of the InsertRowBefore context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub insertRowBeforeToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Content.TableAuthoringService.InsertRow(InsertPositions.Before)
    End Sub

    ''' <summary>
    ''' Handles Click event of the InsertRowAfter context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub insertRowAfterToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Content.TableAuthoringService.InsertRow(InsertPositions.After)
    End Sub

    ''' <summary>
    ''' Handles Click event of the DeleteRow context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub deleteRowToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Content.TableAuthoringService.DeleteRow()
    End Sub

    ''' <summary>
    ''' Handles Click event of the InsertColumnBefore context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub insertColumnBeforeToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Content.TableAuthoringService.InsertColumn(InsertPositions.Before)
    End Sub

    ''' <summary>
    ''' Handles Click event of the InsertColumnAfter context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub insertColumnAfterToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Content.TableAuthoringService.InsertColumn(InsertPositions.After)
    End Sub

    ''' <summary>
    ''' Handles Click event of the DeleteColumn context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub deleteColumnToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Content.TableAuthoringService.DeleteColumn()
    End Sub

    ''' <summary>
    ''' Handles Click event of the MergeCells context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub mergeCellsToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Content.TableAuthoringService.MergeSelectedCells()
    End Sub

    ''' <summary>
    ''' Handles Click event of the YouTubeVideoProperties context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub youTubeVideoPropertiesToolStripMenuItem_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.ToolbarItemOverrider.OnYouTubeVideoInsertButtonClicked(sender, e)
    End Sub

    ''' <summary>
    ''' Handles Click event of the AlignLeft context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_align_left_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Formatting.AlignLeft()
    End Sub

    ''' <summary>
    ''' Handles Click event of the AlignCenter context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_align_center_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Formatting.AlignCenter()
    End Sub

    ''' <summary>
    ''' Handles Click event of the AlignRight context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_align_right_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Formatting.AlignRight()
    End Sub

    ''' <summary>
    ''' Handles Click event of the AlignRemove context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_align_remove_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Formatting.RemoveAlignment()
    End Sub

    ''' <summary>
    ''' Handles Click event of the Cut context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_cut_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Editor.Cut()
    End Sub

    ''' <summary>
    ''' Handles Click event of the Copy context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_copy_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Editor.Copy()
    End Sub

    ''' <summary>
    ''' Handles Click event of the Paste context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_paste_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Editor.Paste()
    End Sub

    ''' <summary>
    ''' Handles Click event of the Delete context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_delete_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Editor.Delete()
    End Sub

    ''' <summary>
    ''' Handles Click event of the SelectAll context menu item
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub contextMenuItem_selectAll_Click(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.Selection.SelectAll()
    End Sub

    ''' <summary>
    ''' Handles ContextMenuShowing event of the WpfHtmlEditor
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub WpfHtmlEditor_OnContextMenuShowing(sender As Object, e As ContextMenuShowingEventArgs)
        Dim customContextMenu As ContextMenu = TryCast(FindResource("ContextMenuCustom"), ContextMenu)
        If customContextMenu Is Nothing Then
            Return
        End If

        Dim contextMenuItem_delete As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_delete"), MenuItem)
        If contextMenuItem_delete IsNot Nothing Then
            contextMenuItem_delete.IsEnabled = WpfHtmlEditor.StateQuery.CanDelete()
        End If

        Dim contextMenuItem_copy As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_copy"), MenuItem)
        If contextMenuItem_copy IsNot Nothing Then
            contextMenuItem_copy.IsEnabled = WpfHtmlEditor.StateQuery.CanCopy()
        End If

        Dim contextMenuItem_cut As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_cut"), MenuItem)
        If contextMenuItem_cut IsNot Nothing Then
            contextMenuItem_cut.IsEnabled = WpfHtmlEditor.StateQuery.CanCut()
        End If

        Dim contextMenuItem_paste As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_paste"), MenuItem)
        If contextMenuItem_paste IsNot Nothing Then
            contextMenuItem_paste.IsEnabled = WpfHtmlEditor.StateQuery.CanPaste()
        End If

        Dim youTubeVideoPropertiesToolStripMenuItem As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "youTubeVideoPropertiesToolStripMenuItem"), MenuItem)
        If youTubeVideoPropertiesToolStripMenuItem IsNot Nothing Then
            youTubeVideoPropertiesToolStripMenuItem.Visibility = If(WpfHtmlEditor.StateQuery.IsYouTubeVideo(), Visibility.Visible, Visibility.Collapsed)
        End If

        Dim contextMenuItem_imageProperties As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_imageProperties"), MenuItem)
        Dim contextMenuItem_linkProperties As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_linkProperties"), MenuItem)
        
        Dim activeHtmlElement As mshtml.IHTMLElement = WpfHtmlEditor.StateQuery.GetActiveHtmlElement()

        If (WpfHtmlEditor.StateQuery.IsImage() _
            AndAlso activeHtmlElement.parentElement.tagName.ToLower() = "a" _
            AndAlso activeHtmlElement.parentElement.innerHTML = activeHtmlElement.outerHTML) Then

            '"Captured : Image link"
            If (contextMenuItem_linkProperties IsNot Nothing AndAlso contextMenuItem_linkProperties.IsVisible) Then
                contextMenuItem_linkProperties.IsChecked = True
            End If

            If (contextMenuItem_imageProperties IsNot Nothing AndAlso contextMenuItem_imageProperties.IsVisible) Then
                contextMenuItem_imageProperties.IsChecked = True
            End If
        Else
            If (contextMenuItem_linkProperties IsNot Nothing AndAlso contextMenuItem_linkProperties.IsVisible) Then
                contextMenuItem_linkProperties.IsChecked = WpfHtmlEditor.StateQuery.IsActiveOrAncestorElementHyperLink()
            End If

            If (contextMenuItem_imageProperties IsNot Nothing AndAlso contextMenuItem_imageProperties.IsVisible) Then
                contextMenuItem_imageProperties.IsChecked = WpfHtmlEditor.StateQuery.IsImage()
            End If
        End If

        Dim toolStripSeparator1Context As Separator = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "toolStripSeparator1Context"), Separator)
        If toolStripSeparator1Context IsNot Nothing Then
            toolStripSeparator1Context.Visibility = If((WpfHtmlEditor.StateQuery.IsTable() OrElse WpfHtmlEditor.StateQuery.IsTableCell() OrElse WpfHtmlEditor.StateQuery.IsHyperLink()), Visibility.Visible, Visibility.Collapsed)
        End If

        Dim contextMenuItem_tableProperties As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_tableProperties"), MenuItem)
        If contextMenuItem_tableProperties IsNot Nothing Then
            contextMenuItem_tableProperties.Visibility = If(WpfHtmlEditor.StateQuery.IsTable() OrElse WpfHtmlEditor.StateQuery.IsTableCell(), Visibility.Visible, Visibility.Collapsed)
        End If

        Dim contextMenuItem_cellProperties As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "contextMenuItem_cellProperties"), MenuItem)
        If contextMenuItem_cellProperties IsNot Nothing Then
            contextMenuItem_cellProperties.Visibility = If(WpfHtmlEditor.StateQuery.IsTableCell(), Visibility.Visible, Visibility.Collapsed)
        End If

        Dim mergeCellsToolStripMenuItem As MenuItem = TryCast(LogicalTreeHelper.FindLogicalNode(customContextMenu, "mergeCellsToolStripMenuItem"), MenuItem)
        If mergeCellsToolStripMenuItem IsNot Nothing Then
            mergeCellsToolStripMenuItem.IsEnabled = WpfHtmlEditor.StateQuery.CanMergeTableCells()
        End If
    End Sub

    ''' <summary>
    ''' Handles Loaded event of the MainWindow
    ''' </summary>
    ''' <param name="sender">The event source.</param>
    ''' <param name="e">The event data.</param>
    Private Sub MainWindow_OnLoaded(sender As Object, e As RoutedEventArgs)
        Dim customContextMenu As ContextMenu = TryCast(FindResource("ContextMenuCustom"), ContextMenu)
        If customContextMenu Is Nothing Then
            Return
        End If

        WpfHtmlEditor.EditorContextMenuStrip = customContextMenu
    End Sub
End Class
