﻿using System;
using System.Windows;
using SpiceLogic.HtmlEditorControl.Domain.BOs.Entities.SpellCheck;

namespace Custom_Spell_Checker
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the Loaded event of the MainWindow
        /// </summary>
        /// <param name="sender">The event source</param>
        /// <param name="e">The event data</param>
        private void MainWindow_OnLoaded(object sender, RoutedEventArgs e)
        {
            WpfHtmlEditor.SpellCheckOptions.CurlyUnderlineImageFilePath = AppDomain.CurrentDomain.BaseDirectory + "\\underline.gif";
        }

        /// <summary>
        /// Handles the Checked and Unchecked events of the NetSpellRadio control
        /// </summary>
        /// <param name="sender">The event source</param>
        /// <param name="e">The event data</param>
        private void NetSpellRadio_OnCheckedChanged(object sender, RoutedEventArgs e)
        {
            if (!IsInitialized)
                return;

            if (NetSpellRadio.IsChecked == true)
            {
                WpfHtmlEditor.SpellCheckOptions.SpellChecker = SpellCheckerEngineTypes.NetSpell;
            }
            else
            {
                WpfHtmlEditor.SpellCheckOptions.SpellChecker = SpellCheckerEngineTypes.Custom;
                WpfHtmlEditor.SpellCheckOptions.CustomSpellCheckerEngine = new CustomSpellCheckerEngine();
            }
        }
    }
}