﻿Imports System.Windows

''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
    Inherits Window

    Public Sub New()
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' Handles the Loaded event of the MainWindow
    ''' </summary>
    ''' <param name="sender">The event source</param>
    ''' <param name="e">The event data</param>
    Private Sub MainWindow_OnLoaded(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.SpellCheckOptions.CurlyUnderlineImageFilePath = AppDomain.CurrentDomain.BaseDirectory + "\underline.gif"
    End Sub

    ''' <summary>
    ''' Handles the Checked and Unchecked events of the NetSpellRadio control
    ''' </summary>
    ''' <param name="sender">The event source</param>
    ''' <param name="e">The event data</param>
    Private Sub NetSpellRadio_OnCheckedChanged(sender As Object, e As RoutedEventArgs)
        If Not IsInitialized Then
            Return
        End If

        If NetSpellRadio.IsChecked = True Then
            WpfHtmlEditor.SpellCheckOptions.SpellChecker = SpiceLogic.HtmlEditorControl.Domain.BOs.Entities.SpellCheck.SpellCheckerEngineTypes.NetSpell
        Else
            WpfHtmlEditor.SpellCheckOptions.SpellChecker = SpiceLogic.HtmlEditorControl.Domain.BOs.Entities.SpellCheck.SpellCheckerEngineTypes.[Custom]
            WpfHtmlEditor.SpellCheckOptions.CustomSpellCheckerEngine = New CustomSpellCheckerEngine()
        End If
    End Sub
End Class