﻿using System.Windows;

namespace Databinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MainWindow"/> class.
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Called when [way button_ on click].
        /// </summary>
        /// <param name="sender">The sender.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void OneWayButton_OnClick(object sender, RoutedEventArgs e)
        {
            OneWay oneWayDialog = new OneWay();
            oneWayDialog.ShowDialog();
        }

        /// <summary>
        /// Handles the OnClick event of the TwoWayLostFocusButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void TwoWayLostFocusButton_OnClick(object sender, RoutedEventArgs e)
        {
            TwoWayLostFocusTrigger lostFocusDialog = new TwoWayLostFocusTrigger();
            lostFocusDialog.ShowDialog();
        }

        /// <summary>
        /// Handles the OnClick event of the TwoWayExplicitButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void TwoWayExplicitButton_OnClick(object sender, RoutedEventArgs e)
        {
            EmailEditor emailEditor = new EmailEditor();
            emailEditor.ShowDialog();
        }

        /// <summary>
        /// Handles the OnClick event of the TwoWayPropertyButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void TwoWayPropertyButton_OnClick(object sender, RoutedEventArgs e)
        {
            TwoWayPropertyChangedTrigger propertyChangedTrigger = new TwoWayPropertyChangedTrigger();
            propertyChangedTrigger.ShowDialog();
        }

        /// <summary>
        /// Handles the OnClick event of the BindingSourceButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void BindingSourceButton_OnClick(object sender, RoutedEventArgs e)
        {
            BindingSource bindingSource = new BindingSource();
            bindingSource.ShowDialog();
        }
    }
}
