﻿using System.Windows;
using Databinding.ViewModel;

namespace Databinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class EmailEditor
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EmailEditor"/> class.
        /// </summary>
        public EmailEditor()
        {
            InitializeComponent();

            DataContext = new EmailViewModel("Initial email subject", "Initial email body");
        }

        /// <summary>
        /// Handles the Click event of the BtnInsertGreeting control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void BtnInsertGreeting_Click(object sender, RoutedEventArgs e)
        {
            wpfHtmlEditor1.UpdateBindings();
        }

        /// <summary>
        /// Handles the Click event of the BtnGetEmail control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void BtnGetEmail_Click(object sender, RoutedEventArgs e)
        {
            wpfHtmlEditor1.UpdateBindings();
        }
    }
}
