﻿using System.Windows;
using Databinding.ViewModel;

namespace Databinding
{
    /// <summary>
    /// Interaction logic for _2Way_LostFocusTrigger.xaml
    /// </summary>
    public partial class TwoWayLostFocusTrigger
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TwoWayLostFocusTrigger"/> class.
        /// </summary>
        public TwoWayLostFocusTrigger()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the OnLoaded event of the TwoWay_LostFocusTrigger control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void TwoWay_LostFocusTrigger_OnLoaded(object sender, RoutedEventArgs e)
        {
            this.DataContext = new LostFocusViewModel {BodyHtml = "initial body html"};
        }

        /// <summary>
        /// Handles the OnClick event of the ShowBodyHtmlButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void ShowBodyHtmlButton_OnClick(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(((LostFocusViewModel) this.DataContext).BodyHtml);
        }
    }
}