﻿using System.Windows;
using Databinding.ViewModel;

namespace Databinding
{
    /// <summary>
    /// Interaction logic for PropertyChangedSourceTrigger.xaml
    /// </summary>
    public partial class TwoWayPropertyChangedTrigger
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TwoWayPropertyChangedTrigger"/> class.
        /// </summary>
        public TwoWayPropertyChangedTrigger()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the OnLoaded event of the TwoWay_PropertyChangedTrigger control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void TwoWay_PropertyChangedTrigger_OnLoaded(object sender, RoutedEventArgs e)
        {
            this.DataContext = new PropertyChangedViewModel {BodyHtml = "initial body html"};
        }

        /// <summary>
        /// Handles the OnClick event of the ShowBodyHtmlButton control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void ShowBodyHtmlButton_OnClick(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(((PropertyChangedViewModel)this.DataContext).BodyHtml);
        }
    }
}