﻿
Imports System.Windows


''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
    ''' <summary>
    ''' Initializes a new instance of the <see cref="MainWindow"/> class.
    ''' </summary>
    Public Sub New()
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' Called when [way button_ on click].
    ''' </summary>
    ''' <param name="sender">The sender.</param>
    ''' <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
    Private Sub OneWayButton_OnClick(sender As Object, e As RoutedEventArgs)
        Dim oneWayDialog As New OneWay()
        oneWayDialog.ShowDialog()
    End Sub

    ''' <summary>
    ''' Handles the OnClick event of the TwoWayLostFocusButton control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
    Private Sub TwoWayLostFocusButton_OnClick(sender As Object, e As RoutedEventArgs)
        Dim lostFocusDialog As New TwoWayLostFocusTrigger()
        lostFocusDialog.ShowDialog()
    End Sub

    ''' <summary>
    ''' Handles the OnClick event of the TwoWayExplicitButton control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
    Private Sub TwoWayExplicitButton_OnClick(sender As Object, e As RoutedEventArgs)
        Dim emailEditor As New EmailEditor()
        emailEditor.ShowDialog()
    End Sub

    ''' <summary>
    ''' Handles the OnClick event of the TwoWayPropertyButton control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
    Private Sub TwoWayPropertyButton_OnClick(sender As Object, e As RoutedEventArgs)
        Dim propertyChangedTrigger As New TwoWayPropertyChangedTrigger()
        propertyChangedTrigger.ShowDialog()
    End Sub

    ''' <summary>
    ''' Handles the OnClick event of the BindingSourceButton control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
    Private Sub BindingSourceButton_OnClick(sender As Object, e As RoutedEventArgs)
        Dim bindingSource As New BindingSource()
        bindingSource.ShowDialog()
    End Sub
End Class