﻿Imports System.Windows
Imports Databinding.ViewModel


''' <summary>
''' Interaction logic for PropertyChangedSourceTrigger.xaml
''' </summary>
Partial Public Class TwoWayPropertyChangedTrigger
    ''' <summary>
    ''' Initializes a new instance of the <see cref="TwoWayPropertyChangedTrigger"/> class.
    ''' </summary>
    Public Sub New()
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' Handles the OnLoaded event of the TwoWay_PropertyChangedTrigger control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
    Private Sub TwoWay_PropertyChangedTrigger_OnLoaded(sender As Object, e As RoutedEventArgs)
        Me.DataContext = New PropertyChangedViewModel() With { _
            .BodyHtml = "initial body html" _
        }
    End Sub

    ''' <summary>
    ''' Handles the OnClick event of the ShowBodyHtmlButton control.
    ''' </summary>
    ''' <param name="sender">The source of the event.</param>
    ''' <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
    Private Sub ShowBodyHtmlButton_OnClick(sender As Object, e As RoutedEventArgs)
        MessageBox.Show(DirectCast(Me.DataContext, PropertyChangedViewModel).BodyHtml)
    End Sub
End Class