﻿
Imports System.ComponentModel

Namespace ViewModel
    Public Class OneWayViewModel
        Implements INotifyPropertyChanged
        Private _bodyHtml As String

        ''' <summary>
        ''' Gets or sets the body HTML.
        ''' </summary>
        ''' <value>
        ''' The body HTML.
        ''' </value>
        Public Property BodyHtml() As String
            Get
                Return _bodyHtml
            End Get
            Set(value As String)
                If _bodyHtml = value Then
                    Return
                End If

                _bodyHtml = value
                OnPropertyChanged("BodyHtml")
            End Set
        End Property


        ''' <summary>
        ''' Occurs when a property value changes.
        ''' </summary>
        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

        ''' <summary>
        ''' Called when [property changed].
        ''' </summary>
        ''' <param name="propertyName">Name of the property.</param>
        Protected Overridable Sub OnPropertyChanged(propertyName As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
        End Sub

    End Class
End Namespace