﻿using System.Windows;
using Dialog_Customization.Dialogs;
using Dialog_Customization.Dialogs.ColorPickerDialog;
using Dialog_Customization.Dialogs.StyleBuilder;

namespace Dialog_Customization
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow
    {
        public MainWindow()
        {
            InitializeComponent();
        }


        private void MainWindow_OnLoaded(object sender, RoutedEventArgs e)
        {
            // OK, it is not necessary that you need to override all dialogs. We have shown example code for overriding
            // all dialogs. You can comment out any of the dialog setting code that you do not need to override.

            WpfHtmlEditor.Dialog.CreateImageDialogMethod = () => new ImageDialog(WpfHtmlEditor.Dialog);
            WpfHtmlEditor.Dialog.CreateHyperlinkDialogMethod = () => new HyperLinkDialog();
            WpfHtmlEditor.Dialog.CreateSearchDialogMethod = () => new SearchWindow();
            WpfHtmlEditor.Dialog.CreateSpellcheckerDialogMethod = () => new SpellCheckerDialog { Options = WpfHtmlEditor.SpellCheckOptions };
            WpfHtmlEditor.Dialog.CreateTableCellDialogMethod = () => new TableCellPropertiesDialog(WpfHtmlEditor.Dialog);
            WpfHtmlEditor.Dialog.CreateTableDialogMethod = () => new TablePropertiesDialog(WpfHtmlEditor.Dialog);
            WpfHtmlEditor.Dialog.CreateSymbolDialogMethod = () => new SymbolDialog();
            WpfHtmlEditor.Dialog.CreateStyleBuilderDialogMethod = () => new WinStyleBuilder(()=> new ColorPickerDialog());
            WpfHtmlEditor.Dialog.CreateYouTubeVideoInsertDialogMethod = () => new YouTubeVideoInsertDialog();
            WpfHtmlEditor.Dialog.CreateColorPickerDialogMethod = () => new ColorPickerDialog();
        }
    }
}
