﻿
Imports Dialog_Customization.Dialogs
Imports Dialog_Customization.Dialogs.ColorPickerDialog
Imports Dialog_Customization.Dialogs.StyleBuilder
Imports SpiceLogic.WpfHtmlEditor.Domain.Dialogs


Public Class MainWindow
    Sub MainWindow_OnLoaded(sender As Object, e As RoutedEventArgs)

        ' OK, it is not necessary that you need to override all dialogs. We have shown example code for overriding
        ' all dialogs. You can comment out any of the dialog setting code that you do not need to override.

        WpfHtmlEditor.Dialog.CreateImageDialogMethod = AddressOf createImageDialog
        WpfHtmlEditor.Dialog.CreateHyperlinkDialogMethod = AddressOf createHyperlinkDialog
        WpfHtmlEditor.Dialog.CreateSearchDialogMethod = AddressOf createSearchDialog
        WpfHtmlEditor.Dialog.CreateSpellcheckerDialogMethod = AddressOf createSpellCheckerDialog
        WpfHtmlEditor.Dialog.CreateTableCellDialogMethod = AddressOf createTableCellPropertiesDialog
        WpfHtmlEditor.Dialog.CreateTableDialogMethod = AddressOf createTableDialog
        WpfHtmlEditor.Dialog.CreateSymbolDialogMethod = AddressOf createSymbolDialog
        WpfHtmlEditor.Dialog.CreateYouTubeVideoInsertDialogMethod = AddressOf createYouTubeDialog
        WpfHtmlEditor.Dialog.CreateStyleBuilderDialogMethod = AddressOf createStyleBuilderDialog
        WpfHtmlEditor.Dialog.CreateColorPickerDialogMethod = AddressOf createColorPickerDialog
    End Sub

    Function createImageDialog() As IImageDialog
        Return New ImageDialog(WpfHtmlEditor.Dialog)
    End Function

    Function createHyperlinkDialog() As IHyperlinkDialog
        Return New HyperLinkDialog()
    End Function

    Function createSearchDialog() As ISearchDialog
        Return New SearchWindow()
    End Function

    Function createSpellCheckerDialog() As ISpellCheckerDialog
        Return New SpellCheckerDialog()
    End Function

    Function createTableCellPropertiesDialog() As ITableCellDialog
        Return New TableCellPropertiesDialog(WpfHtmlEditor.Dialog)
    End Function

    Function createTableDialog() As ITableDialog
        Return New TablePropertiesDialog(WpfHtmlEditor.Dialog)
    End Function

    Function createSymbolDialog() As ISymbolDialog
        Return New SymbolDialog()
    End Function

    Function createYouTubeDialog() As IYouTubeVideoInsertDialog
        Return New YouTubeVideoInsertDialog()
    End Function

    Function createStyleBuilderDialog() As IStyleBuilderDialog
        Return New WinStyleBuilder(AddressOf createColorPickerDialog)
    End Function

    Function createColorPickerDialog() As IColorPickerDialog
        Return New ColorPickerDialog()
    End Function

End Class
