﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using SpiceLogic.HtmlEditorControl.Domain.BOs.UserOptions;

namespace NHunspell_Spell_Checker
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow
    {
        private readonly List<DictionaryFileInfo> _dictionaries = new List<DictionaryFileInfo>();


        public MainWindow()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the Loaded event of the MainWindow
        /// </summary>
        /// <param name="sender">The event source</param>
        /// <param name="e">The event data</param>
        private void MainWindow_OnLoaded(object sender, RoutedEventArgs e)
        {
            WpfHtmlEditor.SpellCheckOptions.CurlyUnderlineImageFilePath = AppDomain.CurrentDomain.BaseDirectory + "curly_underline_for_spell_checker.gif";

            _dictionaries.Add(new DictionaryFileInfo(@"dic\en_US.aff", @"dic\en_US.dic", @"dic\Custom_en_US.dic"));
            _dictionaries.Add(new DictionaryFileInfo(@"dic\fr_FR.aff", @"dic\fr_FR.dic", @"dic\Custom_fr_FR.dic"));

            LanguageCombobox.SelectedIndex = 0;
        }

        /// <summary>
        /// Handles the SelectionChanged event of the LanguageCombobox control
        /// </summary>
        /// <param name="sender">The event source</param>
        /// <param name="e">The event data</param>
        private void LanguageCombobox_OnSelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            WpfHtmlEditor.SpellCheckOptions.DictionaryFile = _dictionaries[LanguageCombobox.SelectedIndex];
        }
    }
}