﻿Imports System.Collections.Generic
Imports System.Windows
Imports System.Windows.Controls
Imports SpiceLogic.HtmlEditorControl.Domain.BOs.UserOptions

''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
    Inherits Window
    Private ReadOnly _dictionaries As New List(Of DictionaryFileInfo)()


    Public Sub New()
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' Handles the Loaded event of the MainWindow
    ''' </summary>
    ''' <param name="sender">The event source</param>
    ''' <param name="e">The event data</param>
    Private Sub MainWindow_OnLoaded(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.SpellCheckOptions.CurlyUnderlineImageFilePath = AppDomain.CurrentDomain.BaseDirectory + "curly_underline_for_spell_checker.gif"

        _dictionaries.Add(New DictionaryFileInfo("dic\en_US.aff", "dic\en_US.dic", "dic\Custom_en_US.dic"))
        _dictionaries.Add(New DictionaryFileInfo("dic\fr_FR.aff", "dic\fr_FR.dic", "dic\Custom_fr_FR.dic"))

        LanguageCombobox.SelectedIndex = 0
    End Sub

    ''' <summary>
    ''' Handles the SelectionChanged event of the LanguageCombobox control
    ''' </summary>
    ''' <param name="sender">The event source</param>
    ''' <param name="e">The event data</param>
    Private Sub LanguageCombobox_OnSelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        WpfHtmlEditor.SpellCheckOptions.DictionaryFile = _dictionaries(LanguageCombobox.SelectedIndex)
    End Sub
End Class