﻿using System.Windows;
using System.Windows.Controls;
using SpiceLogic.WpfHtmlEditor.Toolbars;

namespace Toolbar_Customization
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void MainWindow_OnLoaded(object sender, RoutedEventArgs e)
        {
            //let's hide the toolbars of the editor first
            WpfHtmlEditor.Toolbar1.Visibility = Visibility.Collapsed;
            WpfHtmlEditor.Toolbar2.Visibility = Visibility.Collapsed;

            //let's add the toolbar buttons we need
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Bold);
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Italic);
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Underline);
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Cut);
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Copy);
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Paste);
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontName);
            addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontSize);
            addToolbar2Button(WpfHtmlEditor.Toolbar2, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Hyperlink);
            addToolbar2Button(WpfHtmlEditor.Toolbar2, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Image);
            addToolbar2Button(WpfHtmlEditor.Toolbar2, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontColor);

            WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontName.Style = (Style) FindResource("DefaultComboBoxStyle");
        }

        private void addToolbar1Button(FirstToolbar editorToolbar, Control control)
        {
            editorToolbar.ToolBar.Items.Remove(control);
            Toolbar1.Items.Add(control);
        }

        private void addToolbar2Button(SecondToolbar editorToolbar, Control control)
        {
            editorToolbar.ToolBar.Items.Remove(control);
            Toolbar1.Items.Add(control);
        }

        private void NextExampleButton_OnClick(object sender, RoutedEventArgs e)
        {
            OverridingBehavior overridingBehaviorWindow = new OverridingBehavior();
            overridingBehaviorWindow.Show();
        }
    }
}
