﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace Toolbar_Customization
{
    /// <summary>
    /// Interaction logic for OverridingBehavior.xaml
    /// </summary>
    public partial class OverridingBehavior
    {
        public OverridingBehavior()
        {
            InitializeComponent();
        }

        private void OverridingBehavior_OnLoaded(object sender, RoutedEventArgs e)
        {
            WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.New.Visibility = Visibility.Collapsed;
            Border saveBorder = VisualTreeHelper.GetChild(WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Save, childIndex: 0) as Border;
            if (saveBorder != null)
            {
                ContentPresenter contentPresenter = VisualTreeHelper.GetChild(saveBorder, childIndex: 0) as ContentPresenter;
                if (contentPresenter != null)
                {
                    Image saveImage = VisualTreeHelper.GetChild(contentPresenter, childIndex: 0) as Image;
                    if (saveImage != null)
                    {
                        saveImage.Source = new BitmapImage(new Uri("pack://application:,,,/Toolbar customization;component/Resources/save_accept.png", UriKind.Absolute));
                    }
                }
            }

            WpfHtmlEditor.ToolbarItemOverrider.SaveButtonClicked += ToolbarItemOverriderOnSaveButtonClicked;
            WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Open.ToolTip = "Load content from Database";
        }

        private void ToolbarItemOverriderOnSaveButtonClicked(object sender, RoutedEventArgs routedEventArgs)
        {
            MessageBox.Show("Save the data into Database.", "Custom Save Logic");
        }

        private void AdditionalButton1_OnClick(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Additonal button 1 clicked");
        }

        private void AdditionalButton2_OnClick(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Additonal button 2 clicked");
        }
    }
}
