﻿
Imports System.Windows
Imports System.Windows.Controls
Imports SpiceLogic.WpfHtmlEditor.Toolbars

''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
    Inherits Window
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub MainWindow_OnLoaded(sender As Object, e As RoutedEventArgs)
        'let's hide the toolbars of the editor first
        WpfHtmlEditor.Toolbar1.Visibility = Visibility.Collapsed
        WpfHtmlEditor.Toolbar2.Visibility = Visibility.Collapsed

        'let's add the toolbar buttons we need
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Bold)
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Italic)
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Underline)
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Cut)
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Copy)
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Paste)
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontName)
        addToolbar1Button(WpfHtmlEditor.Toolbar1, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontSize)
        addToolbar2Button(WpfHtmlEditor.Toolbar2, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Hyperlink)
        addToolbar2Button(WpfHtmlEditor.Toolbar2, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Image)
        addToolbar2Button(WpfHtmlEditor.Toolbar2, WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontColor)

        WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.FontName.Style = DirectCast(FindResource("DefaultComboBoxStyle"), Style)
    End Sub

    Private Sub addToolbar1Button(editorToolbar As FirstToolbar, control As Control)
        editorToolbar.ToolBar.Items.Remove(control)
        Toolbar1.Items.Add(control)
    End Sub

    Private Sub addToolbar2Button(editorToolbar As SecondToolbar, control As Control)
        editorToolbar.ToolBar.Items.Remove(control)
        Toolbar1.Items.Add(control)
    End Sub

    Private Sub NextExampleButton_OnClick(sender As Object, e As RoutedEventArgs)
        Dim overridingBehaviorWindow As New OverridingBehavior()
        overridingBehaviorWindow.Show()
    End Sub
End Class