﻿
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Media
Imports System.Windows.Media.Imaging

''' <summary>
''' Interaction logic for OverridingBehavior.xaml
''' </summary>
Partial Public Class OverridingBehavior
    Inherits Window
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub OverridingBehavior_OnLoaded(sender As Object, e As RoutedEventArgs)
        WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.[New].Visibility = Visibility.Collapsed
        Dim saveBorder As Border = TryCast(VisualTreeHelper.GetChild(WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Save, childIndex:=0), Border)
        If saveBorder IsNot Nothing Then
            Dim contentPresenter As ContentPresenter = TryCast(VisualTreeHelper.GetChild(saveBorder, childIndex:=0), ContentPresenter)
            If contentPresenter IsNot Nothing Then
                Dim saveImage As Image = TryCast(VisualTreeHelper.GetChild(contentPresenter, childIndex:=0), Image)
                If saveImage IsNot Nothing Then
                    saveImage.Source = New BitmapImage(New Uri("pack://application:,,,/Toolbar customization;component/Resources/save_accept.png", UriKind.Absolute))
                End If
            End If
        End If

        AddHandler WpfHtmlEditor.ToolbarItemOverrider.SaveButtonClicked, AddressOf ToolbarItemOverriderOnSaveButtonClicked
        WpfHtmlEditor.ToolbarItemOverrider.ToolbarItems.Open.ToolTip = "Load content from Database"
    End Sub

    Private Sub ToolbarItemOverriderOnSaveButtonClicked(sender As Object, routedEventArgs As RoutedEventArgs)
        MessageBox.Show("Save the data into Database.", "Custom Save Logic")
    End Sub

    Private Sub AdditionalButton1_OnClick(sender As Object, e As RoutedEventArgs)
        MessageBox.Show("Additonal button 1 clicked")
    End Sub

    Private Sub AdditionalButton2_OnClick(sender As Object, e As RoutedEventArgs)
        MessageBox.Show("Additonal button 2 clicked")
    End Sub
End Class